changelog shortlog graph tags branches changeset files revisions annotate raw help

Mercurial > infra / bootstrap.sh

changeset 265: fab40b02d833
parent: 8015880d9a0d
child: 0e3229b8409f
author: Richard Westhaver <ellis@rwest.io>
date: Sun, 16 Jun 2024 02:43:16 +0000
permissions: -rwxr-xr-x
description: less verbose, start lisp from autogen.lisp
1 #!/bin/sh
2 set -eu
3 
4 main() {
5  . ./check.sh
6  download --check
7  local _arch=$(_read arch | tr -d '"')
8  local _ext=""
9  case "$_arch" in
10  *windows*)
11  _ext=".exe"
12  ;;
13  esac
14  local _url="https://packy.compiler.company/dist/${_arch}/pack"
15  local _stash
16  if ! _stash=".stash"; then
17  # Because the previous command ran in a subshell, we must manually
18  # propagate exit status.
19  exit 1
20  fi
21  ensure mkdir -p "${_stash}/src"
22  ensure mkdir -p "${_stash}/share/lisp/fasl"
23  ensure mkdir -p "${_stash}/bin"
24  ensure mkdir -p "${_stash}/lib"
25  ensure mkdir -p "${_stash}/include"
26  cd "${_stash}"
27  local _sbcl_pack="sbcl.tar.zst"
28  local _rocksdb_pack="rocksdb.tar.zst"
29  local _core_pack="core.tar.zst"
30  local _core_src_pack="core-source.tar.zst"
31  local _sbcl_url="${_url}/${_sbcl_pack}"
32  local _rocksdb_url="${_url}/${_rocksdb_pack}"
33  local _core_url="${_url}/${_core_pack}"
34  local _core_src_url="${_url}/${_core_src_pack}"
35  ensure download "$_sbcl_url" "$_sbcl_pack" "$_arch"
36  unzstd "${_sbcl_pack}"
37  tar -xf "sbcl.tar"
38  cd sbcl && INSTALL_ROOT=$(realpath ..) sh install.sh && cd ..
39  # ensure download "$_core_src_url" "$_core_src_pack" "$_arch"
40  # unzstd "${_core_src_pack}"
41  # tar -xvf "core-source.tar"
42  # mv core src/
43  # ensure download "$_rocksdb_url" "${_rocksdb_pack}" "$_arch"
44  # unzstd "${_rocksdb_pack}"
45  # tar -xvf "pack/rocksdb.tar"
46  # cp -rf rocksdb/include/* include/
47  # cp -rf rocksdb/*.so lib/
48  ensure download "$_core_url" "${_core_pack}" "$_arch"
49  unzstd "${_core_pack}"
50  tar -xf "core.tar"
51  cp -rf core/bin/* bin/
52  cp -rf core/share/* share/
53  chmod +x bin/*
54  rm -rf core sbcl
55  rm -rf *.tar
56  say "successfully unpacked core"
57  say "starting lisp..."
58  cd .. && .stash/bin/sbcl --core .stash/share/lisp/prelude.core --script autogen.lisp
59  say "OK"
60 }
61 
62 _read() {
63  grep ":$1" $INFRA_HOST_CONFIG | cut -d' ' -f 2-
64 }
65 
66 # Check if curl supports the --retry flag, then pass it to the curl invocation.
67 check_curl_for_retry_support() {
68  local _retry_supported=""
69  # "unspecified" is for arch, allows for possibility old OS using macports, homebrew, etc.
70  if check_help_for "notspecified" "curl" "--retry"; then
71  _retry_supported="--retry 3"
72  if check_help_for "notspecified" "curl" "--continue-at"; then
73  # "-C -" tells curl to automatically find where to resume the download when retrying.
74  _retry_supported="--retry 3 -C -"
75  fi
76  fi
77 
78  RETVAL="$_retry_supported"
79 }
80 
81 # Return cipher suite string specified by user, otherwise return strong TLS 1.2-1.3 cipher suites
82 # if support by local tools is detected. Detection currently supports these curl backends:
83 # GnuTLS and OpenSSL (possibly also LibreSSL and BoringSSL). Return value can be empty.
84 get_ciphersuites_for_curl() {
85  if [ -n "${TLS_CIPHERSUITES-}" ]; then
86  # user specified custom cipher suites, assume they know what they're doing
87  RETVAL="$TLS_CIPHERSUITES"
88  return
89  fi
90 
91  local _openssl_syntax="no"
92  local _gnutls_syntax="no"
93  local _backend_supported="yes"
94  if curl -V | grep -q ' OpenSSL/'; then
95  _openssl_syntax="yes"
96  elif curl -V | grep -iq ' LibreSSL/'; then
97  _openssl_syntax="yes"
98  elif curl -V | grep -iq ' BoringSSL/'; then
99  _openssl_syntax="yes"
100  elif curl -V | grep -iq ' GnuTLS/'; then
101  _gnutls_syntax="yes"
102  else
103  _backend_supported="no"
104  fi
105 
106  local _args_supported="no"
107  if [ "$_backend_supported" = "yes" ]; then
108  # "unspecified" is for arch, allows for possibility old OS using macports, homebrew, etc.
109  if check_help_for "notspecified" "curl" "--tlsv1.2" "--ciphers" "--proto"; then
110  _args_supported="yes"
111  fi
112  fi
113 
114  local _cs=""
115  if [ "$_args_supported" = "yes" ]; then
116  if [ "$_openssl_syntax" = "yes" ]; then
117  _cs=$(get_strong_ciphersuites_for "openssl")
118  elif [ "$_gnutls_syntax" = "yes" ]; then
119  _cs=$(get_strong_ciphersuites_for "gnutls")
120  fi
121  fi
122 
123  RETVAL="$_cs"
124 }
125 
126 # Return cipher suite string specified by user, otherwise return strong TLS 1.2-1.3 cipher suites
127 # if support by local tools is detected. Detection currently supports these wget backends:
128 # GnuTLS and OpenSSL (possibly also LibreSSL and BoringSSL). Return value can be empty.
129 get_ciphersuites_for_wget() {
130  if [ -n "${TLS_CIPHERSUITES-}" ]; then
131  # user specified custom cipher suites, assume they know what they're doing
132  RETVAL="$TLS_CIPHERSUITES"
133  return
134  fi
135 
136  local _cs=""
137  if wget -V | grep -q '\-DHAVE_LIBSSL'; then
138  # "unspecified" is for arch, allows for possibility old OS using macports, homebrew, etc.
139  if check_help_for "notspecified" "wget" "TLSv1_2" "--ciphers" "--https-only" "--secure-protocol"; then
140  _cs=$(get_strong_ciphersuites_for "openssl")
141  fi
142  elif wget -V | grep -q '\-DHAVE_LIBGNUTLS'; then
143  # "unspecified" is for arch, allows for possibility old OS using macports, homebrew, etc.
144  if check_help_for "notspecified" "wget" "TLSv1_2" "--ciphers" "--https-only" "--secure-protocol"; then
145  _cs=$(get_strong_ciphersuites_for "gnutls")
146  fi
147  fi
148 
149  RETVAL="$_cs"
150 }
151 
152 check_help_for() {
153  local _arch
154  local _cmd
155  local _arg
156  _arch="$1"
157  shift
158  _cmd="$1"
159  shift
160 
161  local _category
162  if "$_cmd" --help | grep -q 'For all options use the manual or "--help all".'; then
163  _category="all"
164  else
165  _category=""
166  fi
167 
168  case "$_arch" in
169 
170  *darwin*)
171  if check_cmd sw_vers; then
172  case $(sw_vers -productVersion) in
173  10.*)
174  # If we're running on macOS, older than 10.13, then we always
175  # fail to find these options to force fallback
176  if [ "$(sw_vers -productVersion | cut -d. -f2)" -lt 13 ]; then
177  # Older than 10.13
178  echo "Warning: Detected macOS platform older than 10.13"
179  return 1
180  fi
181  ;;
182  11.*)
183  # We assume Big Sur will be OK for now
184  ;;
185  *)
186  # Unknown product version, warn and continue
187  echo "Warning: Detected unknown macOS major version: $(sw_vers -productVersion)"
188  echo "Warning TLS capabilities detection may fail"
189  ;;
190  esac
191  fi
192  ;;
193 
194  esac
195 
196  for _arg in "$@"; do
197  if ! "$_cmd" --help "$_category" | grep -q -- "$_arg"; then
198  return 1
199  fi
200  done
201 
202  true # not strictly needed
203 }
204 
205 # Return strong TLS 1.2-1.3 cipher suites in OpenSSL or GnuTLS syntax. TLS 1.2
206 # excludes non-ECDHE and non-AEAD cipher suites. DHE is excluded due to bad
207 # DH params often found on servers (see RFC 7919). Sequence matches or is
208 # similar to Firefox 68 ESR with weak cipher suites disabled via about:config.
209 # $1 must be openssl or gnutls.
210 get_strong_ciphersuites_for() {
211  if [ "$1" = "openssl" ]; then
212  # OpenSSL is forgiving of unknown values, no problems with TLS 1.3 values on versions that don't support it yet.
213  echo "TLS_AES_128_GCM_SHA256:TLS_CHACHA20_POLY1305_SHA256:TLS_AES_256_GCM_SHA384:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384"
214  elif [ "$1" = "gnutls" ]; then
215  # GnuTLS isn't forgiving of unknown values, so this may require a GnuTLS version that supports TLS 1.3 even if wget doesn't.
216  # Begin with SECURE128 (and higher) then remove/add to build cipher suites. Produces same 9 cipher suites as OpenSSL but in slightly different order.
217  echo "SECURE128:-VERS-SSL3.0:-VERS-TLS1.0:-VERS-TLS1.1:-VERS-DTLS-ALL:-CIPHER-ALL:-MAC-ALL:-KX-ALL:+AEAD:+ECDHE-ECDSA:+ECDHE-RSA:+AES-128-GCM:+CHACHA20-POLY1305:+AES-256-GCM"
218  fi
219 }
220 
221 # This wraps curl or wget. Try curl first, if not installed,
222 # use wget instead.
223 download() {
224  local _dld
225  local _ciphersuites
226  local _err
227  local _status
228  local _retry
229  if check_cmd curl; then
230  _dld=curl
231  elif check_cmd wget; then
232  _dld=wget
233  else
234  _dld='curl or wget' # to be used in error message of need_cmd
235  fi
236 
237  if [ "$1" = --check ]; then
238  need_cmd "$_dld"
239  elif [ "$_dld" = curl ]; then
240  check_curl_for_retry_support
241  _retry="$RETVAL"
242  get_ciphersuites_for_curl
243  _ciphersuites="$RETVAL"
244  if [ -n "$_ciphersuites" ]; then
245  _err=$(curl $_retry --proto '=https' --tlsv1.2 --ciphers "$_ciphersuites" --silent --show-error --fail --location "$1" --output "$2" 2>&1)
246  _status=$?
247  else
248  echo "Warning: Not enforcing strong cipher suites for TLS, this is potentially less secure"
249  if ! check_help_for "$3" curl --proto --tlsv1.2; then
250  echo "Warning: Not enforcing TLS v1.2, this is potentially less secure"
251  _err=$(curl $_retry --silent --show-error --fail --location "$1" --output "$2" 2>&1)
252  _status=$?
253  else
254  _err=$(curl $_retry --proto '=https' --tlsv1.2 --silent --show-error --fail --location "$1" --output "$2" 2>&1)
255  _status=$?
256  fi
257  fi
258  if [ -n "$_err" ]; then
259  echo "$_err" >&2
260  if echo "$_err" | grep -q 404$; then
261  err "installer for platform '$3' not found, this may be unsupported"
262  fi
263  fi
264  return $_status
265  elif [ "$_dld" = wget ]; then
266  if [ "$(wget -V 2>&1|head -2|tail -1|cut -f1 -d" ")" = "BusyBox" ]; then
267  echo "Warning: using the BusyBox version of wget. Not enforcing strong cipher suites for TLS or TLS v1.2, this is potentially less secure"
268  _err=$(wget "$1" -O "$2" 2>&1)
269  _status=$?
270  else
271  get_ciphersuites_for_wget
272  _ciphersuites="$RETVAL"
273  if [ -n "$_ciphersuites" ]; then
274  _err=$(wget --https-only --secure-protocol=TLSv1_2 --ciphers "$_ciphersuites" "$1" -O "$2" 2>&1)
275  _status=$?
276  else
277  echo "Warning: Not enforcing strong cipher suites for TLS, this is potentially less secure"
278  if ! check_help_for "$3" wget --https-only --secure-protocol; then
279  echo "Warning: Not enforcing TLS v1.2, this is potentially less secure"
280  _err=$(wget "$1" -O "$2" 2>&1)
281  _status=$?
282  else
283  _err=$(wget --https-only --secure-protocol=TLSv1_2 "$1" -O "$2" 2>&1)
284  _status=$?
285  fi
286  fi
287  fi
288  if [ -n "$_err" ]; then
289  echo "$_err" >&2
290  if echo "$_err" | grep -q ' 404 Not Found$'; then
291  err "installer for platform '$3' not found, this may be unsupported"
292  fi
293  fi
294  return $_status
295  else
296  err "Unknown downloader" # should not reach here
297  fi
298 }
299 
300 main "$@" || exit 1